package org.bytedream.quizzledizzle;

import org.bytedream.quizzledizzle.console.Console;
import org.bytedream.quizzledizzle.options.*;
import org.bytedream.quizzledizzle.question.Questions;

import java.io.File;

public class Main {

    public static void main(String[] args) throws Exception {
        Console console = new Console();
        Questions questions = Questions.loadFromCSV(new File("questions.csv"), ";");

        while (true) {
            Option option;

            console.info("1 - Singleplayer");
            console.info("2 - Hotseat");
            console.info("3 - Host multiplayer game (2 players)");
            console.info("4 - Join multiplayer game (2 players)");
            switch (console.askInt("Choice: ")) {
                case -1:
                    console.info("Bye, see ya later");
                    return;
                case 1:
                    option = new Singleplayer(console, questions);
                    break;
                case 2:
                    option = new Hotseat(console, questions);
                    break;
                case 3:
                    option = new MultiplayerHost(console, questions);
                    break;
                case 4:
                    option = new MultiplayerClient(console, questions);
                    break;
                default:
                    console.error("Please enter a number between 1 and 4 (see options above) or 'q' to exit");
                    continue;
            }
            console.clearScreen();
            String exitMessage = option.start();
            console.clearScreen();
            if (exitMessage != null) {
                console.error(exitMessage);
            }
        }
    }

}
