package org.bytedream.quizzledizzle.multiplayer;

import java.io.*;
import java.net.ServerSocket;
import java.net.Socket;

public class Connection {
    public static Client client(String host, int port) throws IOException {
        // creates a new socket an connects directly to the client
        Socket socket = new Socket(host, port);

        BufferedReader reader = new BufferedReader(new InputStreamReader(socket.getInputStream()));
        PrintWriter writer = new PrintWriter(new OutputStreamWriter(socket.getOutputStream()));

        long seed = Long.parseLong(reader.readLine());
        return new Client(socket, reader, writer, seed, false);
    }

    public static Client server(int port) throws IOException {
        // creates new socket server and waits until a client connects
        Socket socket = new ServerSocket(port).accept();

        BufferedReader reader = new BufferedReader(new InputStreamReader(socket.getInputStream()));
        PrintWriter writer = new PrintWriter(new OutputStreamWriter(socket.getOutputStream()));

        // generates and sends a seed which is used to choose if the server or the client sends the questions
        long seed = System.nanoTime();
        writer.println(seed);
        writer.flush();
        return new Client(socket, reader, writer, seed, true);
    }
}
