package org.bytedream.quizzledizzle.options;

import org.bytedream.quizzledizzle.console.Console;
import org.bytedream.quizzledizzle.question.Question;
import org.bytedream.quizzledizzle.question.Questions;

public class Hotseat extends Option {

    public Hotseat(Console console, Questions defaultQuestions) {
        super(console, defaultQuestions);
    }

    @Override
    public String start() throws Exception {
        int playerCount = console.askInt("Player count> ");

        int count = 1;
        while (true) {
            int[] answers = new int[playerCount];

            Question question = defaultQuestions.randomQuestion();
            for (int i = 0; i < playerCount; i++) {
                console.clearScreen();
                console.title("Question " + count);
                console.title("Player " + (i + 1));
                int answer = console.showQuestion(question);
                if (answer == -1) {
                    return null;
                }
                answers[i] = answer;
            }

            console.clearScreen();
            console.info("Results");
            for (int i = 0; i < playerCount; i++) {
                console.info("Player " + (i + 1));
                console.showResult(question, answers[i]);
            }

            if (!console.ask("Continue? [y/N]").toLowerCase().startsWith("y")) {
                return null;
            }

            count++;
        }
    }
}
