package org.bytedream.quizzledizzle.options;

import org.bytedream.quizzledizzle.console.Console;
import org.bytedream.quizzledizzle.multiplayer.Client;
import org.bytedream.quizzledizzle.multiplayer.Connection;
import org.bytedream.quizzledizzle.question.Questions;

import java.io.IOException;

public class MultiplayerClient extends MultiplayerOption {
    public MultiplayerClient(Console console, Questions defaultQuestions) {
        super(console, defaultQuestions);
    }

    @Override
    public String start() throws Exception {
        String ip = console.ask("IP address to connect to> ");
        int port = console.askInt("Port to connect> ");

        Client client;
        try {
            client = Connection.client(ip, port);
            console.info("Connected to server");
        } catch (IOException e) {
            return "Could not connect to the given ip address. Maybe the port or ip is wrong?";
        }

        while (true) {
            if (!this.request(defaultQuestions.randomQuestion(), client)) {
                return null;
            }
        }
    }
}
