package org.bytedream.quizzledizzle.options;

import com.diogonunes.jcolor.Ansi;
import org.bytedream.quizzledizzle.console.Console;
import org.bytedream.quizzledizzle.multiplayer.Client;
import org.bytedream.quizzledizzle.multiplayer.Connection;
import org.bytedream.quizzledizzle.question.Questions;

import java.io.IOException;

public class MultiplayerHost extends MultiplayerOption {
    public MultiplayerHost(Console console, Questions defaultQuestions) {
        super(console, defaultQuestions);
    }

    @Override
    public String start() throws Exception {
        int port = console.askInt("Hosting port> ");

        console.info(Ansi.colorize("Waiting for new connection on port " + port));

        Client client;
        try {
            client = Connection.server(port);
            console.info("Client connected");
        } catch (IOException e) {
            return "Could not create socket. Maybe the port is out of bounce or already taken?";
        }

        while (true) {
            if (!this.request(defaultQuestions.randomQuestion(), client)) {
                return null;
            }
        }
    }
}
