package org.bytedream.quizzledizzle.options;

import org.bytedream.quizzledizzle.console.Console;
import org.bytedream.quizzledizzle.multiplayer.Client;
import org.bytedream.quizzledizzle.question.Question;
import org.bytedream.quizzledizzle.question.Questions;

import java.io.IOException;

public abstract class MultiplayerOption extends Option {

    public MultiplayerOption(Console console, Questions defaultQuestions) {
        super(console, defaultQuestions);
    }

    public boolean request(Question question, Client client) throws IOException {
        int ownAnswer;
        int otherAnswer;
        // possible bug: the server could send the question before the client / other player is listening for it
        if (client.requestSend()) {
            ownAnswer = console.showQuestion(question);
            client.sendQuestion(question);
            otherAnswer = client.receiveAnswer();
            client.sendAnswer(ownAnswer);
        } else {
            question = client.receiveQuestion();
            ownAnswer = console.showQuestion(question);
            client.sendAnswer(ownAnswer);
            otherAnswer = client.receiveAnswer();
        }

        if (ownAnswer == -1 || otherAnswer == -1) {
            client.close();
            return true;
        }

        this.showResult(question, ownAnswer);

        return false;
    }
}
