package org.bytedream.quizzledizzle.options;

import org.bytedream.quizzledizzle.console.Console;
import org.bytedream.quizzledizzle.question.Question;
import org.bytedream.quizzledizzle.question.Questions;

public abstract class Option {

    protected final Console console;
    protected final Questions defaultQuestions;

    private int totalQuestions = 0;
    private int rightQuestions = 0;

    public Option(Console console, Questions defaultQuestions) {
        this.console = console;
        this.defaultQuestions = defaultQuestions;
    }

    public void showResult(Question question, int chosenAnswer) {
        if (chosenAnswer == question.getRightAnswerIndex()) {
            rightQuestions++;
        }
        console.showResult(question, chosenAnswer);
        console.showClearScreen(++totalQuestions, rightQuestions);
    }

    /**
     * Entrypoint when the user has chosen this option
     *
     * @throws Exception
     * @return
     */
    public abstract String start() throws Exception;

}
